package com.mortals.xhx.module.perform.web;

import cn.hutool.core.date.DateUtil;
import com.mortals.framework.exception.AppException;
import com.mortals.framework.model.OrderCol;
import com.mortals.framework.web.BaseCRUDJsonBodyMappingController;
import com.mortals.xhx.base.system.param.service.ParamService;
import com.mortals.xhx.base.system.user.model.UserQuery;
import com.mortals.xhx.base.system.user.service.UserService;
import com.mortals.xhx.common.code.*;
import com.mortals.xhx.module.dept.model.DeptQuery;
import com.mortals.xhx.module.dept.service.DeptService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.ObjectUtils;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import com.mortals.framework.model.Context;
import com.mortals.xhx.module.perform.model.PerformComplainRecordEntity;
import com.mortals.xhx.module.perform.service.PerformComplainRecordService;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * 评价绩效投诉记录信息
 *
 * @author zxfei
 * @date 2023-07-11
 */
@RestController
@RequestMapping("perform/complain/record")
public class PerformComplainRecordController extends BaseCRUDJsonBodyMappingController<PerformComplainRecordService, PerformComplainRecordEntity, Long> {

    @Autowired
    private ParamService paramService;
    @Autowired
    private UserService userService;

    @Autowired
    private DeptService deptService;

    public PerformComplainRecordController() {
        super.setModuleDesc("评价绩效投诉记录信息");
    }

    @Override
    protected void init(Map<String, Object> model, Context context) {
        this.addDict(model, "processStatus", ProcessStatusEnum.getEnumMap());
        this.addDict(model, "checkStatus", CheckStatusEnum.getEnumMap());
        this.addDict(model, "subMethod", SubMethodEnum.getEnumMap());
        this.addDict(model, "subAddType", SubAddTypeEnum.getEnumMap());
        this.addDict(model, "checkType", CheckTypeEnum.getEnumMap());
        this.addDict(model, "deptId", deptService.find(new DeptQuery()).stream().collect(Collectors.toMap(x -> x.getId().toString(), y -> y.getDeptName())));


        this.addDict(model, "complainSource", ReviewSourceEnum.getEnumMap());

        Map<String, String> collect = userService.find(new UserQuery(), getContext()).stream()
                .collect(Collectors.toMap(x -> x.getId().toString(), y -> y.getRealName(), (o, n) -> n));

        this.addDict(model, "createUserId", collect);
        super.init(model, context);
    }

    @Override
    protected void doListBefore(PerformComplainRecordEntity query, Map<String, Object> model, Context context) throws AppException {
        if (ObjectUtils.isEmpty(query.getOrderColList())) {
            query.setOrderColList(Arrays.asList(new OrderCol("complainTime", OrderCol.DESCENDING)));
        } else {
            query.getOrderColList().add(new OrderCol("complainTime", OrderCol.DESCENDING));
        }

        if(ObjectUtils.isEmpty(query.getComplainTimeStart())){
            LocalDateTime currentDate = LocalDateTime.now();
            LocalDateTime firstDayOfMonth = currentDate.withDayOfMonth(1);
            query.setComplainTimeStart(DateUtil.format(firstDayOfMonth,"yyyy-MM-dd"));
            //query.setComplainTimeEnd(DateUtil.formatDate(query.getCreateTime()));
        }
    }
}